#!/usr/bin/env python

import os
from distutils.core import setup,Extension

home = os.getenv("HOME")
boost_path = "%s/work/boost" % home
include_dirs = [boost_path, "src"]
library_dirs = ["%s/pool/lib" % home]
libraries = ["boost_python"]
define_macros = [
  ( "EXTERNAL_TEST", 1 ),
  ( "ANSI_DECLARATORS", 1 ),
  ( "TRILIBRARY", 1 ) ]

setup(name="pyangle",
      version="0.90",
      description="A wrapper around the Triangle 1.4 Mesh generator by Richard Shewchuk",
      author="Andreas Kloeckner",
      author_email="inducer@users.sf.net",
      license = "The Triangle License (~Free if not included in commercial software)",
      url="http://tiker.net/software/#pyangle",
      packages = [ "pyangle" ],
      ext_modules = [
        Extension(
          "pyangle.internals", 
          ["src/pyangle.cpp","src/triangle.c"],
          include_dirs = include_dirs,
          library_dirs = library_dirs,
          libraries = libraries,
          define_macros = define_macros
          )]
     )
